=== src/sig/mayo/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_MAYO_OBJS "")

if(OQS_ENABLE_SIG_mayo_1)
    add_library(mayo_1_opt OBJECT sig_mayo_1.c pqmayo_mayo-1_opt/api.c pqmayo_mayo-1_opt/arithmetic.c pqmayo_mayo-1_opt/mayo.c pqmayo_mayo-1_opt/params.c)
    target_compile_options(mayo_1_opt PUBLIC -DMAYO_VARIANT=MAYO_1 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    target_include_directories(mayo_1_opt PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-1_opt)
    target_include_directories(mayo_1_opt PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_1_opt PUBLIC -DMAYO_VARIANT=MAYO_1 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_1_opt>)
endif()

if(OQS_ENABLE_SIG_mayo_1_avx2)
    add_library(mayo_1_avx2 OBJECT pqmayo_mayo-1_avx2/api.c pqmayo_mayo-1_avx2/arithmetic.c pqmayo_mayo-1_avx2/mayo.c pqmayo_mayo-1_avx2/params.c)
    target_include_directories(mayo_1_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-1_avx2)
    target_include_directories(mayo_1_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_1_avx2 PRIVATE -mavx2)
    target_compile_options(mayo_1_avx2 PUBLIC -DMAYO_VARIANT=MAYO_1 -DMAYO_BUILD_TYPE_AVX2 -DMAYO_AVX -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_1_avx2>)
endif()

if(OQS_ENABLE_SIG_mayo_1_neon)
    add_library(mayo_1_neon OBJECT pqmayo_mayo-1_neon/api.c pqmayo_mayo-1_neon/arithmetic.c pqmayo_mayo-1_neon/mayo.c pqmayo_mayo-1_neon/params.c)
    target_include_directories(mayo_1_neon PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-1_neon)
    target_include_directories(mayo_1_neon PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_1_neon PRIVATE)
    target_compile_options(mayo_1_neon PUBLIC -DMAYO_VARIANT=MAYO_1 -DMAYO_BUILD_TYPE_NEON -DMAYO_NEON -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_1_neon>)
endif()

if(OQS_ENABLE_SIG_mayo_2)
    add_library(mayo_2_opt OBJECT sig_mayo_2.c pqmayo_mayo-2_opt/api.c pqmayo_mayo-2_opt/arithmetic.c pqmayo_mayo-2_opt/mayo.c pqmayo_mayo-2_opt/params.c)
    target_compile_options(mayo_2_opt PUBLIC -DMAYO_VARIANT=MAYO_2 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL)
    target_include_directories(mayo_2_opt PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-2_opt)
    target_include_directories(mayo_2_opt PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_2_opt PUBLIC -DMAYO_VARIANT=MAYO_2 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_2_opt>)
endif()

if(OQS_ENABLE_SIG_mayo_2_avx2)
    add_library(mayo_2_avx2 OBJECT pqmayo_mayo-2_avx2/api.c pqmayo_mayo-2_avx2/arithmetic.c pqmayo_mayo-2_avx2/mayo.c pqmayo_mayo-2_avx2/params.c)
    target_include_directories(mayo_2_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-2_avx2)
    target_include_directories(mayo_2_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_2_avx2 PRIVATE -mavx2)
    target_compile_options(mayo_2_avx2 PUBLIC -DMAYO_VARIANT=MAYO_2 -DMAYO_BUILD_TYPE_AVX2 -DMAYO_AVX -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_2_avx2>)
endif()

if(OQS_ENABLE_SIG_mayo_2_neon)
    add_library(mayo_2_neon OBJECT pqmayo_mayo-2_neon/api.c pqmayo_mayo-2_neon/arithmetic.c pqmayo_mayo-2_neon/mayo.c pqmayo_mayo-2_neon/params.c)
    target_include_directories(mayo_2_neon PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-2_neon)
    target_include_directories(mayo_2_neon PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_2_neon PRIVATE)
    target_compile_options(mayo_2_neon PUBLIC -DMAYO_VARIANT=MAYO_2 -DMAYO_BUILD_TYPE_NEON -DMAYO_NEON -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_2_neon>)
endif()

if(OQS_ENABLE_SIG_mayo_3)
    add_library(mayo_3_opt OBJECT sig_mayo_3.c pqmayo_mayo-3_opt/api.c pqmayo_mayo-3_opt/arithmetic.c pqmayo_mayo-3_opt/mayo.c pqmayo_mayo-3_opt/params.c)
    target_compile_options(mayo_3_opt PUBLIC -DMAYO_VARIANT=MAYO_3 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    target_include_directories(mayo_3_opt PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-3_opt)
    target_include_directories(mayo_3_opt PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_3_opt PUBLIC -DMAYO_VARIANT=MAYO_3 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_3_opt>)
endif()

if(OQS_ENABLE_SIG_mayo_3_avx2)
    add_library(mayo_3_avx2 OBJECT pqmayo_mayo-3_avx2/api.c pqmayo_mayo-3_avx2/arithmetic.c pqmayo_mayo-3_avx2/mayo.c pqmayo_mayo-3_avx2/params.c)
    target_include_directories(mayo_3_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-3_avx2)
    target_include_directories(mayo_3_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_3_avx2 PRIVATE -mavx2)
    target_compile_options(mayo_3_avx2 PUBLIC -DMAYO_VARIANT=MAYO_3 -DMAYO_BUILD_TYPE_AVX2 -DMAYO_AVX -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_3_avx2>)
endif()

if(OQS_ENABLE_SIG_mayo_3_neon)
    add_library(mayo_3_neon OBJECT pqmayo_mayo-3_neon/api.c pqmayo_mayo-3_neon/arithmetic.c pqmayo_mayo-3_neon/mayo.c pqmayo_mayo-3_neon/params.c)
    target_include_directories(mayo_3_neon PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-3_neon)
    target_include_directories(mayo_3_neon PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_3_neon PRIVATE)
    target_compile_options(mayo_3_neon PUBLIC -DMAYO_VARIANT=MAYO_3 -DMAYO_BUILD_TYPE_NEON -DMAYO_NEON -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_3_neon>)
endif()

if(OQS_ENABLE_SIG_mayo_5)
    add_library(mayo_5_opt OBJECT sig_mayo_5.c pqmayo_mayo-5_opt/api.c pqmayo_mayo-5_opt/arithmetic.c pqmayo_mayo-5_opt/mayo.c pqmayo_mayo-5_opt/params.c)
    target_compile_options(mayo_5_opt PUBLIC -DMAYO_VARIANT=MAYO_5 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    target_include_directories(mayo_5_opt PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-5_opt)
    target_include_directories(mayo_5_opt PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_5_opt PUBLIC -DMAYO_VARIANT=MAYO_5 -DMAYO_BUILD_TYPE_OPT -DHAVE_RANDOMBYTES_NORETVAL -DHAVE_STACKEFFICIENT)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_5_opt>)
endif()

if(OQS_ENABLE_SIG_mayo_5_avx2)
    add_library(mayo_5_avx2 OBJECT pqmayo_mayo-5_avx2/api.c pqmayo_mayo-5_avx2/arithmetic.c pqmayo_mayo-5_avx2/mayo.c pqmayo_mayo-5_avx2/params.c)
    target_include_directories(mayo_5_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-5_avx2)
    target_include_directories(mayo_5_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_5_avx2 PRIVATE -mavx2)
    target_compile_options(mayo_5_avx2 PUBLIC -DMAYO_VARIANT=MAYO_5 -DMAYO_BUILD_TYPE_AVX2 -DMAYO_AVX -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_5_avx2>)
endif()

if(OQS_ENABLE_SIG_mayo_5_neon)
    add_library(mayo_5_neon OBJECT pqmayo_mayo-5_neon/api.c pqmayo_mayo-5_neon/arithmetic.c pqmayo_mayo-5_neon/mayo.c pqmayo_mayo-5_neon/params.c)
    target_include_directories(mayo_5_neon PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqmayo_mayo-5_neon)
    target_include_directories(mayo_5_neon PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(mayo_5_neon PRIVATE)
    target_compile_options(mayo_5_neon PUBLIC -DMAYO_VARIANT=MAYO_5 -DMAYO_BUILD_TYPE_NEON -DMAYO_NEON -DHAVE_RANDOMBYTES_NORETVAL)
    set(_MAYO_OBJS ${_MAYO_OBJS} $<TARGET_OBJECTS:mayo_5_neon>)
endif()

set(MAYO_OBJS ${_MAYO_OBJS} PARENT_SCOPE)
