=== src/sig/sphincs/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_SPHINCS_OBJS "")

if(OQS_ENABLE_SIG_sphincs_sha2_128f_simple)
    add_library(sphincs_sha2_128f_simple_clean OBJECT sig_sphincs_sha2_128f_simple.c pqclean_sphincs-sha2-128f-simple_clean/address.c pqclean_sphincs-sha2-128f-simple_clean/context_sha2.c pqclean_sphincs-sha2-128f-simple_clean/fors.c pqclean_sphincs-sha2-128f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-128f-simple_clean/merkle.c pqclean_sphincs-sha2-128f-simple_clean/sign.c pqclean_sphincs-sha2-128f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-128f-simple_clean/utils.c pqclean_sphincs-sha2-128f-simple_clean/utilsx1.c pqclean_sphincs-sha2-128f-simple_clean/wots.c pqclean_sphincs-sha2-128f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_128f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128f-simple_clean)
    target_include_directories(sphincs_sha2_128f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128f_simple_avx2)
    add_library(sphincs_sha2_128f_simple_avx2 OBJECT pqclean_sphincs-sha2-128f-simple_avx2/address.c pqclean_sphincs-sha2-128f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-128f-simple_avx2/fors.c pqclean_sphincs-sha2-128f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-128f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-128f-simple_avx2/merkle.c pqclean_sphincs-sha2-128f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-128f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-128f-simple_avx2/sign.c pqclean_sphincs-sha2-128f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-128f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-128f-simple_avx2/utils.c pqclean_sphincs-sha2-128f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-128f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_128f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128f-simple_avx2)
    target_include_directories(sphincs_sha2_128f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_128f_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128s_simple)
    add_library(sphincs_sha2_128s_simple_clean OBJECT sig_sphincs_sha2_128s_simple.c pqclean_sphincs-sha2-128s-simple_clean/address.c pqclean_sphincs-sha2-128s-simple_clean/context_sha2.c pqclean_sphincs-sha2-128s-simple_clean/fors.c pqclean_sphincs-sha2-128s-simple_clean/hash_sha2.c pqclean_sphincs-sha2-128s-simple_clean/merkle.c pqclean_sphincs-sha2-128s-simple_clean/sign.c pqclean_sphincs-sha2-128s-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-128s-simple_clean/utils.c pqclean_sphincs-sha2-128s-simple_clean/utilsx1.c pqclean_sphincs-sha2-128s-simple_clean/wots.c pqclean_sphincs-sha2-128s-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_128s_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128s-simple_clean)
    target_include_directories(sphincs_sha2_128s_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128s_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128s_simple_avx2)
    add_library(sphincs_sha2_128s_simple_avx2 OBJECT pqclean_sphincs-sha2-128s-simple_avx2/address.c pqclean_sphincs-sha2-128s-simple_avx2/context_sha2.c pqclean_sphincs-sha2-128s-simple_avx2/fors.c pqclean_sphincs-sha2-128s-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-128s-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-128s-simple_avx2/merkle.c pqclean_sphincs-sha2-128s-simple_avx2/sha256avx.c pqclean_sphincs-sha2-128s-simple_avx2/sha256x8.c pqclean_sphincs-sha2-128s-simple_avx2/sign.c pqclean_sphincs-sha2-128s-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-128s-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-128s-simple_avx2/utils.c pqclean_sphincs-sha2-128s-simple_avx2/utilsx8.c pqclean_sphincs-sha2-128s-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_128s_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128s-simple_avx2)
    target_include_directories(sphincs_sha2_128s_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_128s_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128s_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192f_simple)
    add_library(sphincs_sha2_192f_simple_clean OBJECT sig_sphincs_sha2_192f_simple.c pqclean_sphincs-sha2-192f-simple_clean/address.c pqclean_sphincs-sha2-192f-simple_clean/context_sha2.c pqclean_sphincs-sha2-192f-simple_clean/fors.c pqclean_sphincs-sha2-192f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-192f-simple_clean/merkle.c pqclean_sphincs-sha2-192f-simple_clean/sign.c pqclean_sphincs-sha2-192f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-192f-simple_clean/utils.c pqclean_sphincs-sha2-192f-simple_clean/utilsx1.c pqclean_sphincs-sha2-192f-simple_clean/wots.c pqclean_sphincs-sha2-192f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_192f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192f-simple_clean)
    target_include_directories(sphincs_sha2_192f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192f_simple_avx2)
    add_library(sphincs_sha2_192f_simple_avx2 OBJECT pqclean_sphincs-sha2-192f-simple_avx2/address.c pqclean_sphincs-sha2-192f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-192f-simple_avx2/fors.c pqclean_sphincs-sha2-192f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-192f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-192f-simple_avx2/merkle.c pqclean_sphincs-sha2-192f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-192f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-192f-simple_avx2/sha512x4.c pqclean_sphincs-sha2-192f-simple_avx2/sign.c pqclean_sphincs-sha2-192f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-192f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-192f-simple_avx2/utils.c pqclean_sphincs-sha2-192f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-192f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_192f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192f-simple_avx2)
    target_include_directories(sphincs_sha2_192f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_192f_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192s_simple)
    add_library(sphincs_sha2_192s_simple_clean OBJECT sig_sphincs_sha2_192s_simple.c pqclean_sphincs-sha2-192s-simple_clean/address.c pqclean_sphincs-sha2-192s-simple_clean/context_sha2.c pqclean_sphincs-sha2-192s-simple_clean/fors.c pqclean_sphincs-sha2-192s-simple_clean/hash_sha2.c pqclean_sphincs-sha2-192s-simple_clean/merkle.c pqclean_sphincs-sha2-192s-simple_clean/sign.c pqclean_sphincs-sha2-192s-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-192s-simple_clean/utils.c pqclean_sphincs-sha2-192s-simple_clean/utilsx1.c pqclean_sphincs-sha2-192s-simple_clean/wots.c pqclean_sphincs-sha2-192s-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_192s_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192s-simple_clean)
    target_include_directories(sphincs_sha2_192s_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192s_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192s_simple_avx2)
    add_library(sphincs_sha2_192s_simple_avx2 OBJECT pqclean_sphincs-sha2-192s-simple_avx2/address.c pqclean_sphincs-sha2-192s-simple_avx2/context_sha2.c pqclean_sphincs-sha2-192s-simple_avx2/fors.c pqclean_sphincs-sha2-192s-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-192s-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-192s-simple_avx2/merkle.c pqclean_sphincs-sha2-192s-simple_avx2/sha256avx.c pqclean_sphincs-sha2-192s-simple_avx2/sha256x8.c pqclean_sphincs-sha2-192s-simple_avx2/sha512x4.c pqclean_sphincs-sha2-192s-simple_avx2/sign.c pqclean_sphincs-sha2-192s-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-192s-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-192s-simple_avx2/utils.c pqclean_sphincs-sha2-192s-simple_avx2/utilsx8.c pqclean_sphincs-sha2-192s-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_192s_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192s-simple_avx2)
    target_include_directories(sphincs_sha2_192s_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_192s_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192s_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256f_simple)
    add_library(sphincs_sha2_256f_simple_clean OBJECT sig_sphincs_sha2_256f_simple.c pqclean_sphincs-sha2-256f-simple_clean/address.c pqclean_sphincs-sha2-256f-simple_clean/context_sha2.c pqclean_sphincs-sha2-256f-simple_clean/fors.c pqclean_sphincs-sha2-256f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-256f-simple_clean/merkle.c pqclean_sphincs-sha2-256f-simple_clean/sign.c pqclean_sphincs-sha2-256f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-256f-simple_clean/utils.c pqclean_sphincs-sha2-256f-simple_clean/utilsx1.c pqclean_sphincs-sha2-256f-simple_clean/wots.c pqclean_sphincs-sha2-256f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_256f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-256f-simple_clean)
    target_include_directories(sphincs_sha2_256f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_256f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256f_simple_avx2)
    add_library(sphincs_sha2_256f_simple_avx2 OBJECT pqclean_sphincs-sha2-256f-simple_avx2/address.c pqclean_sphincs-sha2-256f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-256f-simple_avx2/fors.c pqclean_sphincs-sha2-256f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-256f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-256f-simple_avx2/merkle.c pqclean_sphincs-sha2-256f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-256f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-256f-simple_avx2/sha512x4.c pqclean_sphincs-sha2-256f-simple_avx2/sign.c pqclean_sphincs-sha2-256f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-256f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-256f-simple_avx2/utils.c pqclean_sphincs-sha2-256f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-256f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_256f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-256f-simple_avx2)
    target_include_directories(sphincs_sha2_256f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_256f_simple_avx2 PRIVATE -mavx2)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_256f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256s_simple)
